<script setup>
import Header from '@/Components/Header.vue';
import PopupComp from '@/Components/Unified/PopupComp.vue';
import { Head, Link, router } from '@inertiajs/vue3';
import { useForm } from '@inertiajs/vue3'
import { reactive, onMounted } from "vue";
import { store, customPopup, compSearch, setupPopup } from '@/store.js';
import draggable from "vuedraggable";
import MainNav from '@/Components/MainNav.vue';
import TableHeader from '@/Components/Unified/TableHeader.vue';
import TableContent from '@/Components/Unified/TableContentSingle.vue';
import Wrap from '@/Layouts/Wrap.vue';
import SetupCustom from '@/Components/Popups/SetupCustom.vue';
import axios from 'axios';
const props = defineProps({
    comp: Object,
    auth: Object,
    users: Object,
})

const torch = () => {
    store.comp.active = 1;
};
function compareRanges(a, b) {
    return a.pivot.range - b.pivot.range;
}
const save = () => {
    router.post(route('comps.update', { 'comp': props.comp.id }), props.comp, {
        preserveScroll: true,
    });
}
const deleteItem = (from, index) => {
    let result = confirm('Вы уверены?');
    if (result) {
        form[from].splice(index, 1);
    }
}
const tern = () => {
    store.detail.active = 1;
};
const togglePrice = () => {
    store.pricesOpen = !store.pricesOpen
}
const toggleCoeffs = () => {
    store.coeffsOpen = !store.coeffsOpen
}

const docstate = reactive({
    type: 0,
    format: 0,
});

function formatMoney(amount, decimalCount = 2, decimal = ".", thousands = ",") {
    try {
        decimalCount = Math.abs(decimalCount);
        decimalCount = isNaN(decimalCount) ? 2 : decimalCount;
        const negativeSign = amount < 0 ? "-" : "";
        let i = parseInt(amount = Math.abs(Number(amount) || 0).toFixed(decimalCount)).toString();
        let j = (i.length > 3) ? i.length % 3 : 0;
        return negativeSign +
            (j ? i.substr(0, j) + thousands : '') +
            i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousands) +
            (decimalCount ? decimal + Math.abs(amount - i).toFixed(decimalCount).slice(2) : "");
    } catch (e) {
        console.log(e)
    }
};
const docget = (action) => {
    axios.post(route('comps.' + action, { 'comp': props.comp.id }), form)
}

const fillParam = (param, value) => {
    router.post(route('comps.param'), {
        param: param,
        value: value,
        id: props.comp.id
    })
}

const getParam = (param) => {
    router.post(route('comps.param'), {
        param: param,
        value: props.comp[param],
        id: props.comp.id
    });
}

</script>

<template>
    <Wrap class="compwrap">
        <Head :title="'Комплектация'" />
        <Header />
        <main class="main">
            <div class="container">
                <div class="page__title">
                    Обзор комплектации
                </div>
                <div class="comp__top">
                    <div class="comp__info">
                        <div class="comp__title">Комплектация</div>
                        <div class="comp__value">{{ props.comp.id }}</div>
                        <div class="comp__title">Статус</div>
                        <div class="comp__value" v-if="props.comp.status == 1">Закрыта</div>
                        <div class="comp__value" v-if="props.comp.status == 0">В работе</div>
                    </div>
                    <div class="comp__actions">
                        <div class="comp__docs">
                            <div class="button excel" :class="{ 'active': docstate.type == 1 }"
                                @click="docstate.type = 1">Excel</div>
                            <div class="button pdf" :class="{ 'active': docstate.type == 2 }"
                                @click="docstate.type = 2">
                                PDF</div>
                            <div class="button word" :class="{ 'active': docstate.type == 3 }"
                                @click="docstate.type = 3">
                                Word</div>
                        </div>
                        <div class="comp__docs" v-if="docstate.type">
                            <div class="button kp" :class="{ 'active': docstate.format == 1 }"
                                @click="docstate.format = 1">КП</div>
                            <div class="button full" :class="{ 'active': docstate.format == 2 }"
                                @click="docstate.format = 2">Общая комплектация</div>
                        </div>
                        <div class="comp__docs" v-if="docstate.format">
                            <div class="button email" @click="docget('mail')">Email</div>
                            <div class="button close" @click="docget('download')">Скачать</div>
                        </div>
                        <div class="comp__docs" style="margin-left: auto" v-if="props.comp.status == 0">
                            <div class="button close" @click="fillParam('status', 1)">Закрыть</div>
                        </div>
                        <div class="comp__docs" style="margin-left: auto"
                            v-if="$page.props.auth.user.role_id == 3 && props.comp.status == 1">
                            <div class="button close" @click="fillParam('status', 0)">Вернуть в работу</div>
                        </div>
                    </div>
                </div>
                <div class="comp__personnel">
                    <div class="comp__title">Отв. менеджер</div>
                    <select class="comp__value" v-model="props.comp.manager_id" @change="getParam('manager_id')">
                        <option value="null"  selected>Выберите</option>
                        <template v-for="item in $page['props']['users']">
                            <option :value="item.id">{{ item.name }}</option>
                        </template>
                    </select>
                    <div class="comp__title">Отв. инженер</div>
                    <select class="comp__value" v-model="props.comp.engineer_id" @change="getParam('engineer_id')">
                        <option value="null"  selected>Выберите</option>
                        <template v-for="item in $page['props']['users']">
                            <option :value="item.id">{{ item.name }}</option>
                        </template>
                    </select>
                    <div class="comp__title">Наблюдатель</div>
                    <select class="comp__value" v-model="props.comp.watcher_id" @change="getParam('watcher_id')">
                        <option :value="null" selected>Выберите</option>
                        <template v-for="item in $page['props']['users']">
                            <option :value="item.id">{{ item.name }}</option>
                        </template>
                    </select>
                </div>
                <div class="comp__personnel _info">
                    <div class="comp__title">Сделка</div>
                    <input class="comp__value" v-model="props.comp.deal" @change="getParam('deal')">
                    <div class="comp__title">Наименование оборудования</div>
                    <input class="comp__value" v-model="props.comp.detail" @change="getParam('detail')">
                </div>
                <div class="main__nav">
                    <Link :href='"/comps/add"' class="main__button">Новая комплектация</Link>
                    <Link :href='"/comps"' class="main__button">Мои комплектации</Link>
                    <Link :href='"/comps/add/" + current' class="main__button">Создать на основе текущей</Link>
                    <div @click="setupPopup('add', false, 4, props.comp.id)" class="main__button" style="margin-left: auto">Добавить доп.оборудование</div>
                    <div @click="compSearch(props.comp.id)" class="main__button">Добавить позицию</div>
                </div>
                <div class="engi" v-if="$page.props.auth.user.role_id > 1">
                    <div class="engi__block" @click="togglePrice()">
                        <div class="engi__check" :class="{ '_active': store.pricesOpen }"></div>
                        <div class="engi__title">Закупочные цены</div>
                    </div>
                    <div class="engi__block" @click="toggleCoeffs()" v-if="$page.props.auth.user.role_id > 1">
                        <div class="engi__check" :class="{ '_active': store.coeffsOpen }"></div>
                        <div class="engi__title">Коэффициенты</div>
                    </div>
                </div>
                <template v-if="props.comp.elements.filter(item=>item.type == 3).length > 0">
                    <div class="child_block table-preserve" :class="{
                        '_prices': store.pricesOpen,
                        '_coeffs': store.coeffsOpen,
                    }">
                        <div class="block__title">Оборудование</div>
                        <table class="_lesser">
                            <TableHeader></TableHeader>
                            <draggable :list="props.comp.elements.filter(item=>item.type == 3)" tag="tbody"
                                item-key="element.pivot.range">
                                <template #item="{ element, index }">
                                    <TableContent :item="element" :index="index" :item.key="element.pivot.range"
                                        @delete="deleteItem('children_equipments', index)" />
                                </template>
                            </draggable>
                        </table>
                    </div>
                </template>
                <template v-if="props.comp.elements.filter(item=>item.type == 2).length > 0">
                    <div class="child_block table-preserve" :class="{
                        '_prices': store.pricesOpen,
                        '_coeffs': store.coeffsOpen,
                    }">
                        <div class="block__title">Детали</div>
                        <table class="_lesser">
                            <TableHeader></TableHeader>
                            <draggable :list="props.comp.elements.filter(item=>item.type == 2)" tag="tbody"
                                item-key="element.pivot.range">
                                <template #item="{ element, index }">
                                    <TableContent :item="element" :index="index" :item.key="element.pivot.range"
                                        @delete="deleteItem('children_equipments', index)" />
                                </template>
                            </draggable>
                        </table>
                    </div>
                </template>
                <template v-if="props.comp.elements.filter(item=>item.type == 1).length > 0">
                    <div class="child_block table-preserve" :class="{
                        '_prices': store.pricesOpen,
                        '_coeffs': store.coeffsOpen,
                    }">
                        <div class="block__title">Комплектующие</div>
                        <table class="_lesser">
                            <TableHeader></TableHeader>
                            <draggable :list="props.comp.elements.filter(item=>item.type == 1)" tag="tbody"
                                item-key="element.pivot.range">
                                <template #item="{ element, index }">
                                    <TableContent :item="element" :index="index" :item.key="element.pivot.range"
                                        @delete="deleteItem('children_equipments', index)" />
                                </template>
                            </draggable>
                        </table>
                    </div>
                </template>
                <template v-if="props.comp.elements.filter(item=>item.type == 4).length > 0">
                    <div class="child_block table-preserve" :class="{
                        '_prices': store.pricesOpen,
                        '_coeffs': store.coeffsOpen,
                    }">
                        <div class="block__title">Доп. оборудование</div>
                        <table class="_lesser">
                            <TableHeader></TableHeader>
                            <draggable :list="props.comp.elements.filter(item=>item.type == 4)" tag="tbody"
                                item-key="element.pivot.range">
                                <template #item="{ element, index }">
                                    <TableContent :item="element" :index="index" :item.key="element.pivot.range"
                                        @delete="deleteItem('children_equipments', index)" />
                                </template>
                            </draggable>
                        </table>
                    </div>
                </template>
            </div>
            <div class="totals">
                <div class="total__row">
                    <div class="total__title _bold">Итоговая цена закупки: </div>
                    <div class="total__value"><span v-html="formatMoney(props.comp.total, 2, '.', ' ')"></span> <span
                            style="font-weight: 500">₽</span></div>
                </div>
                <div class="total__row">
                    <div class="total__title _bold">Итоговая цена: </div>
                    <div class="total__value"><span v-html="formatMoney(props.comp.price, 2, '.', ' ')"></span> <span
                            style="font-weight: 500">₽</span></div>
                </div>
                <div class="total__row">
                    <div class="total__title _bold">Маржа: </div>
                    <div class="total__value"><span
                            v-html="formatMoney(props.comp.price - props.comp.total, 2, '.', ' ')"></span>
                        <span style="font-weight: 500">₽</span>
                    </div>
                </div>
                <div class="total__row">
                    <div class="total__title _bold">Общий вес: </div>
                    <div class="total__value"><span v-html="formatMoney(props.comp.total_weight, 2, '.', ' ')"></span>
                    </div>
                </div>
            </div>
        </main>
    </Wrap>
</template>
<style scoped>
tr>*:first-child {
    width: 42px;
}
</style>
